# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.service_client import SDKClient
from msrest import Serializer, Deserializer

from ._configuration import RecoveryServicesClientConfiguration
from .operations import VaultCertificatesOperations
from .operations import RegisteredIdentitiesOperations
from .operations import ReplicationUsagesOperations
from .operations import PrivateLinkResourcesOperations
from .operations import RecoveryServicesOperations
from .operations import VaultsOperations
from .operations import Operations
from .operations import VaultExtendedInfoOperations
from .operations import UsagesOperations
from . import models


class RecoveryServicesClient(SDKClient):
    """Recovery Services Client

    :ivar config: Configuration for client.
    :vartype config: RecoveryServicesClientConfiguration

    :ivar vault_certificates: VaultCertificates operations
    :vartype vault_certificates: azure.mgmt.recoveryservices.operations.VaultCertificatesOperations
    :ivar registered_identities: RegisteredIdentities operations
    :vartype registered_identities: azure.mgmt.recoveryservices.operations.RegisteredIdentitiesOperations
    :ivar replication_usages: ReplicationUsages operations
    :vartype replication_usages: azure.mgmt.recoveryservices.operations.ReplicationUsagesOperations
    :ivar private_link_resources: PrivateLinkResources operations
    :vartype private_link_resources: azure.mgmt.recoveryservices.operations.PrivateLinkResourcesOperations
    :ivar recovery_services: RecoveryServices operations
    :vartype recovery_services: azure.mgmt.recoveryservices.operations.RecoveryServicesOperations
    :ivar vaults: Vaults operations
    :vartype vaults: azure.mgmt.recoveryservices.operations.VaultsOperations
    :ivar operations: Operations operations
    :vartype operations: azure.mgmt.recoveryservices.operations.Operations
    :ivar vault_extended_info: VaultExtendedInfo operations
    :vartype vault_extended_info: azure.mgmt.recoveryservices.operations.VaultExtendedInfoOperations
    :ivar usages: Usages operations
    :vartype usages: azure.mgmt.recoveryservices.operations.UsagesOperations

    :param credentials: Credentials needed for the client to connect to Azure.
    :type credentials: :mod:`A msrestazure Credentials
     object<msrestazure.azure_active_directory>`
    :param subscription_id: The subscription Id.
    :type subscription_id: str
    :param str base_url: Service URL
    """

    def __init__(
            self, credentials, subscription_id, base_url=None):

        self.config = RecoveryServicesClientConfiguration(credentials, subscription_id, base_url)
        super(RecoveryServicesClient, self).__init__(self.config.credentials, self.config)

        client_models = {k: v for k, v in models.__dict__.items() if isinstance(v, type)}
        self.api_version = '2016-06-01'
        self._serialize = Serializer(client_models)
        self._deserialize = Deserializer(client_models)

        self.vault_certificates = VaultCertificatesOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.registered_identities = RegisteredIdentitiesOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.replication_usages = ReplicationUsagesOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.private_link_resources = PrivateLinkResourcesOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.recovery_services = RecoveryServicesOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.vaults = VaultsOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.operations = Operations(
            self._client, self.config, self._serialize, self._deserialize)
        self.vault_extended_info = VaultExtendedInfoOperations(
            self._client, self.config, self._serialize, self._deserialize)
        self.usages = UsagesOperations(
            self._client, self.config, self._serialize, self._deserialize)
